import os
import gettext
import sys


def find_locale_dir():

    fullpath = os.path.abspath(sys.argv[0])
    d, f = os.path.split(fullpath)

    if f == 'gdesklets':
        # we're in $prefix/bin/
        d = os.path.split(d)[0]
        return os.path.join(d, 'share', 'locale')

    elif f == 'gdesklets-daemon' or f == 'gdesklets-shell':
        # we're in $prefix/share/gdesklets
        return os.path.join(d, os.pardir, 'share', 'locale')


def Translator(domain):
    try:
        localedir = find_locale_dir()
        return gettext.translation(domain, localedir).gettext
    except IOError:
        return lambda s: s
